<template>
  <el-form
    ref="manualCryptoCurrencyDepositFormRef"
    label-position="top"
    :model="manualCryptoCurrencyDepositFormData"
    :rules="manualCryptoCurrencyDepositRules"
    label-width="210px"
    class="px-5 py-6 unset-height"
    :validate-on-rule-change="false"
    style="
      height: 85vh;
      overflow-y: scroll;
      margin-bottom: 5px;
    "
  >
    <h4>{{ $t("from") }}</h4>
    <el-form-item :label="$t('wallet_type')" prop="walletType">
      <el-select
        v-model="manualCryptoCurrencyDepositFormData.walletType"
        class="w-full"
        @visible-change="onVisibleChange"
        @change="onChangeSelect"
        @blur="onChangeSelect"
      >
        <el-option
          v-for="player in playerCryptocurrencyOptions"
          :key="player"
          :label="player.WalletType"
          :value="player.WalletType"
        />
      </el-select>
    </el-form-item>
    <el-form-item :label="$t('your_wallet_address')" prop="playerWalletAddress">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.playerWalletAddress"
        v-un-focus
        oninput="this.value = this.value.replace(/[^a-zA-Z0-9]/g, '')"
        type="text"
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.amount"
        v-un-focus
        :placeholder="amountPlaceholder"
        type="text"
        @input="onInputValue($event, manualCryptoCurrencyDepositFormData, 'amount')"
      >
        <template v-if="checkedCurrency" #append>
          <span>000</span>
        </template>
      </el-input>
      <span v-if="checkedCurrency" class="order-1 text-xs fc-hint mt-3"
        >{{
          $t(
            `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}
      </span>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="manualCryptoCurrencyDepositFormData.depositTime"
        type="datetime"
        format="YYYY-MM-DD h:mm:ss A"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
    >
      <div v-if="allowTheme" class="slip-card">
        <div class="flex flex-col items-center pt-3 gap-2">
          <div class="h-8 w-8">
            <img
              :src="getAssetImage('assets/theme/new_black_theme/upload.png')"
              alt=""
            />
          </div>
          <span class="text-sm font-normal leading-4 --text">{{ $t("upload_your_image") }}</span>
          <el-upload
            ref="uploadSlipImageFRef"
            v-model="manualCryptoCurrencyDepositFormData.slipUpload"
            class="upload-demo"
            accept=".jpg, .png, .jpeg, .svg"
            :limit="1"
            :on-exceed="handleSlipImageExceed"
            :on-change="getSlipImage"
            :on-remove="removeSlipImage"
            :auto-upload="false"
          >
            <el-button plain round type="primary">
              <div class="flex items-center">
                <UploadIcon
                  class="w-4 h-4 !fill-[var(--primary)] !stroke-none !mr-0"
                />
                <span>
                  {{ $t("choose_file") }}
                </span>
              </div>
            </el-button>
          </el-upload>
        </div>
      </div>
      <el-upload
        v-else
        ref="uploadSlipImageFRef"
        v-model="manualCryptoCurrencyDepositFormData.slipUpload"
        class="upload-demo w-full"
        accept=".jpg, .png, .jpeg, .svg"
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
      >
        <el-button plain round type="primary">{{
          $t("choose_file")
        }}</el-button>
      </el-upload>
    </el-form-item>
    <h4>{{ $t("to") }}</h4>
    <el-form-item :label="$t('company_channel')">
      <el-select
        v-model="manualCryptoCurrencyDepositFormData.companyBankId"
        class="w-full"
        @visible-change="onVisibleChange"
        @change="onChangeSelect"
        @blur="onChangeSelect"
      >
        <el-option
          v-for="company in companyCryptocurrencyOptions"
          :key="company.Id"
          :label="company.CompanyChannel"
          :value="company.Id"
        />
      </el-select>
    </el-form-item>
    <el-form-item :label="$t('deposit_address')" prop="cryptoDepositAddress" class="isDisabled-container">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.cryptoDepositAddress"
        v-un-focus
        type="text"
        :disabled="true"
      >
        <template #suffix>
          <span
            class="flex items-center"
            @click="
              copyTextToClipBoard(
                manualCryptoCurrencyDepositFormData.cryptoDepositAddress
              )
            "
          >
            {{ $t("copy") }}
          </span>
        </template>
      </el-input>
    </el-form-item>
    <div class="w-full flex justify-center items-center">
      <div class="bg-white p-2 rounded">
        <qrcode-vue
          :value="manualCryptoCurrencyDepositFormData.cryptoDepositAddress"
          :size="120"
        ></qrcode-vue>
      </div>
    </div>
    <div class="text-center mt-10 submit-button-deposit">
      <el-button
        v-if="isUploadImage"
        :disabled="isUploadImage"
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        :disabled="isProccesing"
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("submit") }}</el-button
      >
    </div>
  </el-form>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import QrcodeVue from "qrcode.vue";
import { ProfileDto } from "@/models/getProfileResponse";
import { IGetManualCryptoCurrencyTransactionResponse } from "@/models/getManualCryptoCurrencyTransactionResponse";
import { store } from "@/store";
import UploadIcon from "~/assets/icons/upload_icon.svg?component";

export default defineComponent({
  name: "ManualCryptoCurrencyDeposit",
  components: {
    QrcodeVue,
    UploadIcon,
  },
  props: {
    manualCryptoCurrency: {
      type: Object as PropType<IGetManualCryptoCurrencyTransactionResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
  },
  setup(props) {
    const { manualCryptoCurrency, profile } = toRefs(props);

    const {
      getSlipImage,
      removeSlipImage,
      uploadSlipImageFRef,
      copyTextToClipBoard,
      handleSlipImageExceed,
      onChangeSelect,
      onVisibleChange,
      onInputValue,
    } = commonHelper;

    const {
      checkedCurrency,
      playerCryptocurrencyOptions: PlayerCryptocurrencyOptions,
      companyCryptocurrencyOptions: CompanyCryptocurrencyOptions,
      manualCryptoDepositMin,
      manualCryptoDepositMax,
      manualCryptoCurrencyDepositFormRef,
      manualCryptoCurrencyDepositFormData,
      manualCryptoCurrencyDepositRules,
      submitManualCryptoCurrencyDeposit,
      isProccesing,
      isUploadImage,
      companyFlowSettings,
      amountPlaceholder,
    } = useManualCryptoCurrencyDeposit(manualCryptoCurrency, profile);
    const allowTheme = computed(
      () =>
        store.state.selectedThemeName === "main" ||
        store.state.selectedThemeName === "china"
    );
    const { getAssetImage } = commonHelper;
    return {
      copyTextToClipBoard,
      checkedCurrency,
      playerCryptocurrencyOptions: PlayerCryptocurrencyOptions,
      companyCryptocurrencyOptions: CompanyCryptocurrencyOptions,
      manualCryptoDepositMin,
      manualCryptoDepositMax,
      manualCryptoCurrencyDepositFormRef,
      manualCryptoCurrencyDepositFormData,
      manualCryptoCurrencyDepositRules,
      submitManualCryptoCurrencyDeposit,
      handleSlipImageExceed,
      uploadSlipImageFRef,
      getSlipImage,
      removeSlipImage,
      isProccesing,
      isUploadImage,
      companyFlowSettings,
      amountPlaceholder,
      allowTheme,
      getAssetImage,
      onChangeSelect,
      onVisibleChange,
      onInputValue,
    };
  },
});
</script>
<style scoped>
.slip-card {
  width: 100%;
  height: 132px;
  background: var(--background1);
  border: 1px dashed #4d5080;
  border-radius: 8px;
}
:deep(.slip-card button.el-button) {
  width: 152px;
  height: 40px;
  background: transparent !important;
  color: var(--primary) !important;
}
</style>
<style>
.el-date-editor {
  --el-date-editor-width: 100%;
}
</style>
